{$I-,S-}
program DumpHasp;
uses misc,strings,dos;
CONST
   ver = '1.2';
(*
 * A list of the HASP services
 *)
   IS_HASP                      =  1;
   GET_HASP_CODE                =  2;
   READ_MEMO                    =  3;
   WRITE_MEMO                   =  4;
   GET_HASP_STATUS              =  5;
   GET_ID_NUM                   =  6;
   READ_MEMO_BLOCK              = 50;
   WRITE_MEMO_BLOCK             = 51;

(*
 * A list of the TimeHASP services
 *)
   TIMEHASP_SET_TIME            = 70;
   TIMEHASP_GET_TIME            = 71;
   TIMEHASP_SET_DATE            = 72;
   TIMEHASP_GET_DATE            = 73;
   TIMEHASP_WRITE_MEMORY        = 74;
   TIMEHASP_READ_MEMORY         = 75;
   TIMEHASP_WRITE_MEMORY_BLOCK  = 76;
   TIMEHASP_READ_MEMORY_BLOCK   = 77;
   TIMEHASP_GET_ID_NUM          = 78;

(*
 * A list of NetHASP services.
 *)
   NET_LAST_STATUS              = 40;
   NET_GET_HASP_CODE            = 41;
   NET_LOGIN                    = 42;
   NET_LOGOUT                   = 43;
   NET_READ_WORD                = 44;
   NET_WRITE_WORD               = 45;
   NET_GET_ID_NUMBER            = 46;
   NET_READ_MEMO_BLOCK          = 52;
   NET_WRITE_MEMO_BLOCK         = 53;

   OK                           = 0;
   NET_READ_ERROR               = 131;
   NET_WRITE_ERROR              = 132;


(*
 * A list of LptNum codes for different key types
 *)
   LPT_IBM_ALL_HASP25  = 0;
   LPT_IBM_ALL_HASP36  = 50;
   LPT_NEC_ALL_HASP36  = 60;

   MEMO_BUFFER_SIZE  = 56;
   MAX_COUNT = $7FFF;
{$L hasptp.obj}
{$F+}
procedure  hasp (Service, SeedCode, LptNum, Pass1, Pass2 : integer;
                 var p1,p2,p3,p4 : integer);external;
{$F-}

(*
 * Global variables.
 *)
Type
_HASPDumpHdr = record
   _hdr :string[8];     	{'HASPDump'}
   _date:string[16];    	{date}

   _type:word;			{hasp type}
   _misc:longint;
  _pwdHi:word;
  _pwdLo:word;
   _sn  :longint;		{serial nu}
   _misc1:string[5];
   _bf  :array [0..MEMO_BUFFER_SIZE] of word;
end;


var
   LptNum : integer;
   Pass1            : integer;
   Pass2            : integer;
   p1,p2,p3,p4      : integer;
   Service          : integer;
   ID               : longint;
   i                : integer;
   DmpHdr	    : _HASPDumpHdr;
   k,m: integer;
   SeedCode:word;
   HaspMemoBuff     : array[1..MEMO_BUFFER_SIZE] of word;
   ProductType      : integer;
   f:text;
   f1:file;

function AsciiDot(tt:byte):char;
begin
if ((tt>$1F) and (tt<$B0)) or ((tt>$DF) and (tt<$F0)) then AsciiDot:=chr(tt)
else AsciiDot:='.';
end;

(*
 ***************************************
 *
 *  DumpHASPSeedCodes;
 *
 *  Description: Dumps HASP-3 Seed codes
 *
 ***************************************
 *)
   procedure DumpHASPSeedCodes(Seedx:word);
var
buf1 : array [1..4] of word;
begin

(*
 * Get HASP code
 *)
    Service := GET_HASP_CODE;
    hasp ( Service, Seedx, LptNum, Pass1, Pass2, p1, p2, p3, p4 );
    writeln('_'+Hexw(Seedx)+':');
    writeln('mov	ax, ', hexw(p1));
    writeln('mov	bx, ', hexw(p2));
    writeln('mov	cx, ', hexw(p3));
    writeln('mov	dx, ', hexw(p4));
    writeln('ret');

end;

BEGIN     { main program body }
   writeln;
   writeln( ' HASP memory dumper v',ver,', (x)1997 by MeteO');

{
(*
 * Get the passwords.
 *)
    writeX( 'Enter the first HASP password  : '+#0 );
    readln( Pass1 );
    writeX( 'Enter the second HASP password : '+#0 );
    readln( Pass2 );
}
 Pass1:=$b91;
 pass2:=$622;

(*
 * Determine the key type.
 *)
    LptNum := LPT_IBM_ALL_HASP25;
(*
 * Check if any HASP is connected
 *)
    writeln('Checking if any HASP is connected...');
    Service := IS_HASP;
    hasp ( Service, SeedCode, LptNum, Pass1, Pass2, p1, p2, p3, p4 );
    if p1 = 0 then
    begin
      writeln('No HASP key was found.');
      exit;
    end
    else
      writeln('A HASP key was found.');

   DumpHASPSeedCodes($000);
   DumpHASPSeedCodes($22b);
   DumpHASPSeedCodes($456);
   DumpHASPSeedCodes($681);
   DumpHASPSeedCodes($8ac);
   DumpHASPSeedCodes($ad7);
   DumpHASPSeedCodes($d02);
   DumpHASPSeedCodes($f2d);

END.

